<?
if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true) die();

$arParams["IBLOCK_TYPE"] = trim($arParams["IBLOCK_TYPE"]);
if(strlen($arParams["IBLOCK_TYPE"])<=0)
 	$arParams["IBLOCK_TYPE"] = "news";
$arParams["IBLOCK_ID"] = trim($arParams["IBLOCK_ID"]);
$arParams["FOLDER"] = trim($arParams["FOLDER"]);
if (!$arParams['FOLDER'])
	return;

if (!$arParams['SOURCE'])
	$arParams['SOURCE'] = 'DETAIL_TEXT';

if (!$USER->IsAdmin())
{
	$this->AbortResultCache();
	ShowError(' ');
	return;
}

global $path;
$path = rtrim($_SERVER['DOCUMENT_ROOT'],'/\\').'/'.trim($arParams['FOLDER'],'/\\');
if (!is_dir($path))
	if (!mkdir($path))
	{
		ShowError('   : '.$path);
		return;
	}


if(!CModule::IncludeModule("iblock"))
{
	$this->AbortResultCache();
	ShowError(GetMessage("IBLOCK_MODULE_NOT_INSTALLED"));
	return;
}

$chars = array('?','\\','/','*'); // 
if ($_POST['export'])
{
	$arResult = array();

	$rs = CIBlockSection::GetList(array('left_margin'=>'asc'),array('IBLOCK_ID'=>$arParams['IBLOCK_ID']));
	while($f = $rs->Fetch())
	{
		$folder = '';
		$arSections[$f['DEPTH_LEVEL']] = str_replace($chars,' ',$f['NAME']); //  
		for($i=1;$i<=$f['DEPTH_LEVEL'];$i++)
			$folder .= '/'.$arSections[$i];

		$dir = $path.'/'.$folder;
		$dir = str_replace('\\','/',$dir);
		$dir = str_replace('//','/',$dir);

		if ($arParams['CHARSET'])
			$tmp = mb_convert_encoding($dir,$arParams['CHARSET'],SITE_CHARSET);
		else
			$tmp = $dir;

		if (!is_dir($tmp))
			if (!mkdir($tmp))
			{
				ShowError('   : '.$dir);
				return;
			}
		$arResult['SECTIONS'][$f['ID']] = $dir;
	}

	$arSelect = array('ID','IBLOCK_ID','IBLOCK_SECTION_ID','NAME','DETAIL_TEXT_TYPE','PREVIEW_TEXT_TYPE',$arParams['SOURCE']);
	$rs = CIBlockElement::GetList(array('name'=>'asc'),array('IBLOCK_ID'=>$arParams['IBLOCK_ID'],false,false,$arSelect));
	while($el = $rs->GetNextElement())
	{
		$f = $el->GetFields();
		$dir = $arResult['SECTIONS'][$f['IBLOCK_SECTION_ID']];
		$file = ($dir?$dir:$path) .'/'. str_replace($chars,' ',$f['NAME']); //  

		if ($arParams['CHARSET'])
			$tmp = mb_convert_encoding($file,$arParams['CHARSET'],SITE_CHARSET);
		else
			$tmp = $file;

		if (in_array($arParams['SOURCE'],array('DETAIL_TEXT','PREVIEW_TEXT')))
		{ //    
			$tmp .= $f[$arParams['SOURCE'] . '_TYPE'] == 'text' ? '.txt' : '.html';
			if ($f0 = fopen($tmp,'wb'))
			{
				fwrite($f0,$f[$arParams['SOURCE']]);
				fclose($f0);
			}
			else
			{
				ShowError('   : '.$file.' [ '.$f['ID'].']');
				if (!$arParams['SKIP_ERRORS'])
					return;
			}
		}
		else
		{ //  
			$p = $el->GetProperties();
			$val = $p[$arParams['SOURCE']]['VALUE'];
			if ($val)
			{
				$from = $_SERVER['DOCUMENT_ROOT'].CFile::GetPath($val);
				if (!copy($from,$tmp))
				{
					ShowError('   : '.$from.'  '.$file.' [ '.$f['ID'].']');
					if (!$arParams['SKIP_ERRORS'])
						return;
				}
			}
		}

		$arResult['ELEMENTS'][$f['ID']] = $file;
	}
}
elseif ($_POST['import'])
{
	$arSections = array();

	function Scan($folder, $arParams)
	{
		global $path;
		static $arSections, $ob1, $ob2;

		$pos = strrpos($folder,'/');
		if ($pos!==false)
		{
			$parent_dir = substr($folder,0,$pos);
			$name = substr($folder,$pos + 1);
		}
		else
		{
			$parent_dir = '';
			$name = $folder;
		}

		$IBLOCK_SECTION_ID = intval($arSections[$parent_dir]);

		if ($arParams['CHARSET'])
			$name = mb_convert_encoding($name,SITE_CHARSET,$arParams['CHARSET']);

		if (is_dir($path.$folder)) // dir
		{
			if ($folder)
			{
			############################
				if (!$ob1)
					$ob1 = new CIBlockSection;
				$id = $ob1->Add(
					array(
						"IBLOCK_ID" => $arParams['IBLOCK_ID'],
						"IBLOCK_SECTION_ID" => $IBLOCK_SECTION_ID,
						"NAME" => $name
					)
				);

				if ($id)
					$arSections[$folder] = $id;
				else
				{
					ShowError('   : '.$name.' ('.mb_convert_encoding($folder,SITE_CHARSET,$arParams['CHARSET']).')');
					return;
				}
			############################
			}

			$dir = opendir($path.$folder);
			while($item = readdir($dir))
			{
				if ($item == '.' || $item == '..')
					continue;
				Scan($folder.'/'.$item, $arParams);
			}
			closedir($dir);
		}
		elseif (is_file($path.$folder)) // file
		{
			############################
			$IBLOCK_SECTION_ID = intval($arSections[$parent_dir]);
			if (!$ob2)
				$ob2 = new CIBlockElement;
			$arFields = array(
					"IBLOCK_ID" => $arParams['IBLOCK_ID'],
					"IBLOCK_SECTION_ID" => $IBLOCK_SECTION_ID,
				);

			if (in_array($arParams['SOURCE'],array('DETAIL_TEXT','PREVIEW_TEXT')))
			{
				$arFields[$arParams['SOURCE']] = file_get_contents($path.$folder);
				if (substr($name,'-4')=='.txt')
				{
					$name = substr($name,0,-4);
					$arFields[$arParams['SOURCE'].'_TYPE'] = 'text';
				}
				elseif (substr($name,'-5')=='.html')
				{
					$name = substr($name,0,-5);
					$arFields[$arParams['SOURCE'].'_TYPE'] = 'html';
				}

			}
			else // 
			{
				$arFields['PROPERTY_VALUES'][$arParams['SOURCE']] = CFile::MakeFileArray($path.$folder);
			}

			$arFields["NAME"] = $name;

			$id = $ob2->Add($arFields);

			if (!$id)
			{
				ShowError('   : '.$name);
				return;
			}
			############################
		}
	}

	Scan('', $arParams);
}

$this->IncludeComponentTemplate();

?>
